import{s as Ye,n as Ze,o as et}from"../chunks/scheduler.25b97de1.js";import{S as tt,i as rt,g as l,s as n,r as m,A as at,h as o,f as t,c as s,j as $,u as i,x as E,k as v,y as c,a,v as d,d as f,t as u,w as p}from"../chunks/index.d9030fc9.js";import{D as _}from"../chunks/Docstring.e257edda.js";import{H as ne,E as nt}from"../chunks/EditOnGithub.91d95064.js";function st(He){let b,se,re,le,P,oe,T,je="This page lists all of Transformers general utility functions that are found in the file <code>utils.py</code>.",me,C,qe="Most of those are only useful if you are studying the general code in the library.",ie,L,de,h,D,De,Q,Ue="Enum with more explicit error message for missing values.",fe,y,M,Me,W,Be=`Possible values for the <code>padding</code> argument in <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizerBase.<strong>call</strong>()</a>. Useful for tab-completion in an
IDE.`,ue,x,z,ze,X,Ae=`Possible values for the <code>return_tensors</code> argument in <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizerBase.<strong>call</strong>()</a>. Useful for
tab-completion in an IDE.`,pe,I,ce,k,S,ge,V,H,$e,j,q,ve,U,B,_e,A,G,be,O,he,g,F,Ie,Y,Ge="Descriptor that mimics @property but caches output in member variable.",ke,Z,Oe="From tensorflow_datasets",Se,ee,Fe="Built-in in functools from Python 3.8.",ye,K,xe,N,R,Ve,te,Ke="Module class that surfaces all objects but only performs associated imports when the objects are requested.",Ne,J,Ee,ae,we;return P=new ne({props:{title:"General Utilities",local:"general-utilities",headingTag:"h1"}}),L=new ne({props:{title:"Enums and namedtuples",local:"transformers.utils.ExplicitEnum",headingTag:"h2"}}),D=new _({props:{name:"class transformers.utils.ExplicitEnum",anchor:"transformers.utils.ExplicitEnum",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/generic.py#L489"}}),M=new _({props:{name:"class transformers.utils.PaddingStrategy",anchor:"transformers.utils.PaddingStrategy",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/generic.py#L501"}}),z=new _({props:{name:"class transformers.TensorType",anchor:"transformers.TensorType",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/generic.py#L512"}}),I=new ne({props:{title:"Special Decorators",local:"transformers.add_start_docstrings",headingTag:"h2"}}),S=new _({props:{name:"transformers.add_start_docstrings",anchor:"transformers.add_start_docstrings",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/doc.py#L23"}}),H=new _({props:{name:"transformers.utils.add_start_docstrings_to_model_forward",anchor:"transformers.utils.add_start_docstrings_to_model_forward",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/doc.py#L31"}}),q=new _({props:{name:"transformers.add_end_docstrings",anchor:"transformers.add_end_docstrings",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/doc.py#L53"}}),B=new _({props:{name:"transformers.utils.add_code_sample_docstrings",anchor:"transformers.utils.add_code_sample_docstrings",parameters:[{name:"*docstr",val:""},{name:"processor_class",val:" = None"},{name:"checkpoint",val:" = None"},{name:"output_type",val:" = None"},{name:"config_class",val:" = None"},{name:"mask",val:" = '[MASK]'"},{name:"qa_target_start_index",val:" = 14"},{name:"qa_target_end_index",val:" = 15"},{name:"model_cls",val:" = None"},{name:"modality",val:" = None"},{name:"expected_output",val:" = None"},{name:"expected_loss",val:" = None"},{name:"real_checkpoint",val:" = None"},{name:"revision",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/doc.py#L1064"}}),G=new _({props:{name:"transformers.utils.replace_return_docstrings",anchor:"transformers.utils.replace_return_docstrings",parameters:[{name:"output_type",val:" = None"},{name:"config_class",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/doc.py#L1162"}}),O=new ne({props:{title:"Special Properties",local:"transformers.utils.cached_property",headingTag:"h2"}}),F=new _({props:{name:"class transformers.utils.cached_property",anchor:"transformers.utils.cached_property",parameters:[{name:"fget",val:" = None"},{name:"fset",val:" = None"},{name:"fdel",val:" = None"},{name:"doc",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/generic.py#L42"}}),K=new ne({props:{title:"Other Utilities",local:"transformers.utils._LazyModule",headingTag:"h2"}}),R=new _({props:{name:"class transformers.utils._LazyModule",anchor:"transformers.utils._LazyModule",parameters:[{name:"name",val:""},{name:"module_file",val:""},{name:"import_structure",val:""},{name:"module_spec",val:" = None"},{name:"extra_objects",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/import_utils.py#L1511"}}),J=new nt({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/internal/file_utils.md"}}),{c(){b=l("meta"),se=n(),re=l("p"),le=n(),m(P.$$.fragment),oe=n(),T=l("p"),T.innerHTML=je,me=n(),C=l("p"),C.textContent=qe,ie=n(),m(L.$$.fragment),de=n(),h=l("div"),m(D.$$.fragment),De=n(),Q=l("p"),Q.textContent=Ue,fe=n(),y=l("div"),m(M.$$.fragment),Me=n(),W=l("p"),W.innerHTML=Be,ue=n(),x=l("div"),m(z.$$.fragment),ze=n(),X=l("p"),X.innerHTML=Ae,pe=n(),m(I.$$.fragment),ce=n(),k=l("div"),m(S.$$.fragment),ge=n(),V=l("div"),m(H.$$.fragment),$e=n(),j=l("div"),m(q.$$.fragment),ve=n(),U=l("div"),m(B.$$.fragment),_e=n(),A=l("div"),m(G.$$.fragment),be=n(),m(O.$$.fragment),he=n(),g=l("div"),m(F.$$.fragment),Ie=n(),Y=l("p"),Y.textContent=Ge,ke=n(),Z=l("p"),Z.textContent=Oe,Se=n(),ee=l("p"),ee.textContent=Fe,ye=n(),m(K.$$.fragment),xe=n(),N=l("div"),m(R.$$.fragment),Ve=n(),te=l("p"),te.textContent=Ke,Ne=n(),m(J.$$.fragment),Ee=n(),ae=l("p"),this.h()},l(e){const r=at("svelte-u9bgzb",document.head);b=o(r,"META",{name:!0,content:!0}),r.forEach(t),se=s(e),re=o(e,"P",{}),$(re).forEach(t),le=s(e),i(P.$$.fragment,e),oe=s(e),T=o(e,"P",{"data-svelte-h":!0}),E(T)!=="svelte-1d4d2gz"&&(T.innerHTML=je),me=s(e),C=o(e,"P",{"data-svelte-h":!0}),E(C)!=="svelte-11r0tff"&&(C.textContent=qe),ie=s(e),i(L.$$.fragment,e),de=s(e),h=o(e,"DIV",{class:!0});var Pe=$(h);i(D.$$.fragment,Pe),De=s(Pe),Q=o(Pe,"P",{"data-svelte-h":!0}),E(Q)!=="svelte-u4x3ci"&&(Q.textContent=Ue),Pe.forEach(t),fe=s(e),y=o(e,"DIV",{class:!0});var Te=$(y);i(M.$$.fragment,Te),Me=s(Te),W=o(Te,"P",{"data-svelte-h":!0}),E(W)!=="svelte-af7cif"&&(W.innerHTML=Be),Te.forEach(t),ue=s(e),x=o(e,"DIV",{class:!0});var Ce=$(x);i(z.$$.fragment,Ce),ze=s(Ce),X=o(Ce,"P",{"data-svelte-h":!0}),E(X)!=="svelte-1amghpj"&&(X.innerHTML=Ae),Ce.forEach(t),pe=s(e),i(I.$$.fragment,e),ce=s(e),k=o(e,"DIV",{class:!0});var Re=$(k);i(S.$$.fragment,Re),Re.forEach(t),ge=s(e),V=o(e,"DIV",{class:!0});var Je=$(V);i(H.$$.fragment,Je),Je.forEach(t),$e=s(e),j=o(e,"DIV",{class:!0});var Qe=$(j);i(q.$$.fragment,Qe),Qe.forEach(t),ve=s(e),U=o(e,"DIV",{class:!0});var We=$(U);i(B.$$.fragment,We),We.forEach(t),_e=s(e),A=o(e,"DIV",{class:!0});var Xe=$(A);i(G.$$.fragment,Xe),Xe.forEach(t),be=s(e),i(O.$$.fragment,e),he=s(e),g=o(e,"DIV",{class:!0});var w=$(g);i(F.$$.fragment,w),Ie=s(w),Y=o(w,"P",{"data-svelte-h":!0}),E(Y)!=="svelte-4cuoeh"&&(Y.textContent=Ge),ke=s(w),Z=o(w,"P",{"data-svelte-h":!0}),E(Z)!=="svelte-1mfkm3t"&&(Z.textContent=Oe),Se=s(w),ee=o(w,"P",{"data-svelte-h":!0}),E(ee)!=="svelte-1x2w0p5"&&(ee.textContent=Fe),w.forEach(t),ye=s(e),i(K.$$.fragment,e),xe=s(e),N=o(e,"DIV",{class:!0});var Le=$(N);i(R.$$.fragment,Le),Ve=s(Le),te=o(Le,"P",{"data-svelte-h":!0}),E(te)!=="svelte-tjmjug"&&(te.textContent=Ke),Le.forEach(t),Ne=s(e),i(J.$$.fragment,e),Ee=s(e),ae=o(e,"P",{}),$(ae).forEach(t),this.h()},h(){v(b,"name","hf:doc:metadata"),v(b,"content",lt),v(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){c(document.head,b),a(e,se,r),a(e,re,r),a(e,le,r),d(P,e,r),a(e,oe,r),a(e,T,r),a(e,me,r),a(e,C,r),a(e,ie,r),d(L,e,r),a(e,de,r),a(e,h,r),d(D,h,null),c(h,De),c(h,Q),a(e,fe,r),a(e,y,r),d(M,y,null),c(y,Me),c(y,W),a(e,ue,r),a(e,x,r),d(z,x,null),c(x,ze),c(x,X),a(e,pe,r),d(I,e,r),a(e,ce,r),a(e,k,r),d(S,k,null),a(e,ge,r),a(e,V,r),d(H,V,null),a(e,$e,r),a(e,j,r),d(q,j,null),a(e,ve,r),a(e,U,r),d(B,U,null),a(e,_e,r),a(e,A,r),d(G,A,null),a(e,be,r),d(O,e,r),a(e,he,r),a(e,g,r),d(F,g,null),c(g,Ie),c(g,Y),c(g,ke),c(g,Z),c(g,Se),c(g,ee),a(e,ye,r),d(K,e,r),a(e,xe,r),a(e,N,r),d(R,N,null),c(N,Ve),c(N,te),a(e,Ne,r),d(J,e,r),a(e,Ee,r),a(e,ae,r),we=!0},p:Ze,i(e){we||(f(P.$$.fragment,e),f(L.$$.fragment,e),f(D.$$.fragment,e),f(M.$$.fragment,e),f(z.$$.fragment,e),f(I.$$.fragment,e),f(S.$$.fragment,e),f(H.$$.fragment,e),f(q.$$.fragment,e),f(B.$$.fragment,e),f(G.$$.fragment,e),f(O.$$.fragment,e),f(F.$$.fragment,e),f(K.$$.fragment,e),f(R.$$.fragment,e),f(J.$$.fragment,e),we=!0)},o(e){u(P.$$.fragment,e),u(L.$$.fragment,e),u(D.$$.fragment,e),u(M.$$.fragment,e),u(z.$$.fragment,e),u(I.$$.fragment,e),u(S.$$.fragment,e),u(H.$$.fragment,e),u(q.$$.fragment,e),u(B.$$.fragment,e),u(G.$$.fragment,e),u(O.$$.fragment,e),u(F.$$.fragment,e),u(K.$$.fragment,e),u(R.$$.fragment,e),u(J.$$.fragment,e),we=!1},d(e){e&&(t(se),t(re),t(le),t(oe),t(T),t(me),t(C),t(ie),t(de),t(h),t(fe),t(y),t(ue),t(x),t(pe),t(ce),t(k),t(ge),t(V),t($e),t(j),t(ve),t(U),t(_e),t(A),t(be),t(he),t(g),t(ye),t(xe),t(N),t(Ne),t(Ee),t(ae)),t(b),p(P,e),p(L,e),p(D),p(M),p(z),p(I,e),p(S),p(H),p(q),p(B),p(G),p(O,e),p(F),p(K,e),p(R),p(J,e)}}}const lt='{"title":"General Utilities","local":"general-utilities","sections":[{"title":"Enums and namedtuples","local":"transformers.utils.ExplicitEnum","sections":[],"depth":2},{"title":"Special Decorators","local":"transformers.add_start_docstrings","sections":[],"depth":2},{"title":"Special Properties","local":"transformers.utils.cached_property","sections":[],"depth":2},{"title":"Other Utilities","local":"transformers.utils._LazyModule","sections":[],"depth":2}],"depth":1}';function ot(He){return et(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends tt{constructor(b){super(),rt(this,b,ot,st,Ye,{})}}export{ut as component};
